<?php
/**
 *
 * This product includes software developed by the Horde Project (http://www.horde.org/).
 *
 * See the enclosed file COPYING for license information (GPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 *
 * @author  Andre Pawlowski aka sqall <sqall@h4des.org>
 */

//das absolute Eleusis directory wird als Konstante definiert
//um damit config Dateien zu includieren
@define('ELEUSIS_BASE', dirname(__FILE__));

//die Basis von Eleusis wird includiert
//um die Anmeldung zu ueberpruefen
require_once(ELEUSIS_BASE . '/lib/base.php');
//die Konfigurationsdatei von Eleusis wird includiert
//um alle Eleusis Einstellungen in diesem Skript nutzen zu koennen
require(ELEUSIS_BASE . '/config/conf.php');
//das Menu von Eleusis wird includiert
//damit das Menu dem Benutzer angezeigt wird
require_once(ELEUSIS_BASE . '/list.php');

echo "<div class=\"header\">Eleusis Passwordstore</div>";
echo "<p><b>notice:</b> javascripts must be enabled!</p>";

//hier wird ueberprueft ob der zu speichernde Name gesetzt ist
if(isset($_POST['eleusis_name']) && $_POST['eleusis_name'] != "" ) {
   //hier wird ueberprueft ob das zu speichernde Passwort gesetzt ist
   if(isset($_POST['eleusis_password']) && $_POST['eleusis_password'] != "") {
      //hier wird ueberprueft ob die Passwoerter unterschiedlich sind
      if($_POST['eleusis_password'] == $_POST['eleusis_password_repeat']) {
         //hier wird ueberprueft ob die zu speichernde Beschreibung gesetzt ist
         if(isset($_POST['eleusis_description']) && $_POST['eleusis_description'] != "") {

            //hier wird ueberprueft ob ein ";" in die Felder zum speichern eingesetzt wurde
            if(strpos($_POST['eleusis_name'],';') === false && strpos($_POST['eleusis_password'],';') === false && strpos($_POST['eleusis_description'],';') === false) {
            }
            else {
               //falls ja, wird abgebrochen weil das ";" ein Trennzeichen beim Speichern ist
               echo "Error: input contains \";\"!";
               exit(1);
            }

            //hier wird ueberprueft ob der Name des passwordstores gesetzt ist
            if(isset($_GET['passwordfile']) && $_GET['passwordfile'] != "" ) {
               //hier wird überprüft ob jemand aus dem Ordner der passwordfiles ausbrechen will
               if(strpos($_GET['passwordfile'],'/.') === false && strpos($_GET['passwordfile'],'./') === false) {
                  //hier wird ueberprueft ob das Passwort des passwordstores gesetzt ist
                  if(isset($_POST['passwordfile_password']) && $_POST['passwordfile_password'] != "") {
         
                     //das passwordfile wird geoeffnet      
                     $passwordfile_handle=fopen(ELEUSIS_BASE . '/passwordstore/passwords/' . $_GET['passwordfile'], 'r');
                     //das verschluesselte passwordfile wird ausgelesen und in einer Variable gespeichert
                     $encrypted_passwordfile = fread($passwordfile_handle, filesize(ELEUSIS_BASE . '/passwordstore/passwords/' . $_GET['passwordfile']));
                     //das passwordfile wird wieder geschlossen
                     fclose($passwordfile_handle);
                     //das passwordfile wird entschluesselt
                     $decrypted_passwordfile = Eleusis::DecryptData($_POST['passwordfile_password'], $encrypted_passwordfile);
                     //die Variable mit dem verschluesselten Passwordfile wird geloescht
                     unset($encrypted_passwordfile);
                     //hier wird ueberprueft ob die entschluesselung fehlerhaft war
                     if(substr($decrypted_passwordfile, 0, strpos($decrypted_passwordfile, "\n")) != "0;eleusis_passwordfile") {
                        echo "Error: wrong password for decryption!";
                        exit(1);
                     }

                     //hier wird die neue id fuer das neu zu speichernde passwort ermittelt
                     $zwerg=substr($decrypted_passwordfile, 0, strrpos($decrypted_passwordfile, "\n"));
                     //wenn "\n" in dem zwischenergebnis nicht mehr vorkommt, existierte nur der erste Eintrag von eleusis
                     if(strrpos($zwerg, "\n") === false) {
                        $newid=1;
                     }
                     //hier wird nun die letzte id ermittelt und mit 1 addiert
                     else {
                        $zwerg=substr($zwerg, strrpos($zwerg, "\n"));
                        $zwerg=substr($zwerg, 0, strpos($zwerg, ';'));
                        $newid=$zwerg+1;
                     }

                     //der zu speichernde nutzername,password und beschreibung werden zum entschluesselten passwordfile hinzugefuegt
                     $decrypted_passwordfile.=$newid . ';' . $_POST['eleusis_name'] . ';' . $_POST['eleusis_password'] . ';' . $_POST['eleusis_description'] . "\n";
                     //das passwordfile wird geoeffnet
                     $passwordfile_handle=fopen(ELEUSIS_BASE . '/passwordstore/passwords/' . $_GET['passwordfile'], 'w');
                     //schreibt die komplette variable $decrypted_passwordfile verschluesselt in das passwordfile
                     fwrite($passwordfile_handle, Eleusis::EncryptData($_POST['passwordfile_password'], $decrypted_passwordfile));
                     //schliesst datei wieder
                     fclose($passwordfile_handle);
                     echo "Password added.<br />";
                  }
                  //falls das Passwort des passwordstores nicht gesetzt ist
                  else {
                     echo "Error: \$passwordfile_password in add.php is not set or is empty!"; 
                     exit(1);
                  }
               }
               //falls die Variable manipuliert wurde
               else {
                  echo "Error: \$passwordfile in add.php contains illegal characters!";
                  exit(1);
               } 
            }
            //falls der Name des passwordstores nicht gesetzt ist
            else {
               echo "Error: \$passwordfile in add.php is not set or is empty!"; 
               exit(1);
            }    
         }
         //falls die zu speichernde Beschreibung nicht gesetzt ist
         else {
            echo "Error: \$eleusis_description in add.php is not set or is empty!"; 
            exit(1);
         }
      }
      //falls die Passwoerter unterschiedlich sind
      else {
         echo "Error: \$eleusis_password and \$eleusis_password_repeat are different!"; 
         exit(1);
      }
   }
   //falls das zu speichernde Passwort nicht gesetzt ist
   else {
      echo "Error: \$eleusis_password in add.php is not set or is empty!"; 
      exit(1);
   }
}
//falls der zu speichernde Name nicht gesetzt ist
else {
   echo "Error: \$eleusis_name in add.php is not set or is empty!"; 
   exit(1);
}


//der footer wird includiert
require ELEUSIS_TEMPLATES . '/common-footer.inc';
?>