<?php
/**
 *
 * This product includes software developed by the Horde Project (http://www.horde.org/).
 *
 * See the enclosed file COPYING for license information (GPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 *
 * @author  Andre Pawlowski aka sqall <sqall@h4des.org>
 */

//das absolute Eleusis directory wird als Konstante definiert
//um damit config Dateien zu includieren
@define('ELEUSIS_BASE', dirname(__FILE__));

//die Basis von Eleusis wird includiert
//um die Anmeldung zu ueberpruefen
require_once(ELEUSIS_BASE . '/lib/base.php');
//die Konfigurationsdatei von Eleusis wird includiert
//um alle Eleusis Einstellungen in diesem Skript nutzen zu koennen
require(ELEUSIS_BASE . '/config/conf.php');
//das Menu von Eleusis wird includiert
//damit das Menu dem Benutzer angezeigt wird
require_once(ELEUSIS_BASE . '/list.php');

echo "<div class=\"header\">Eleusis Passwordstore</div>";
echo "<p><b>notice:</b> javascripts must be enabled!</p>";

//hier wird ueberprueft ob der Name des passwordstores gesetzt ist
if(isset($_POST['eleusis_name']) && $_POST['eleusis_name'] != "" ) {
   //hier wird überprüft ob jemand aus dem Ordner der passwordfiles ausbrechen will
   if(strpos($_POST['eleusis_name'],'/.') === false && strpos($_POST['eleusis_name'],'./') === false) {

      //hier wird ueberprueft ob ein ";" in die Felder zum speichern eingesetzt wurde
      if(strpos($_POST['eleusis_name'],';') === false) {
      }
      else {
         //falls ja, wird abgebrochen weil das ";" ein Trennzeichen beim Speichern ist
         echo "Error: input contains \";\"!";
         exit(1);
      }

      //hier wird ueberprueft ob das Passwort des passwordstores gesetzt ist
      if(isset($_POST['eleusis_password']) && $_POST['eleusis_password'] != "") {
         //hier wird ueberprueft ob die Passwoerter zur Ueberpruefung der Richtigkeit unterschiedlich sind
         if($_POST['eleusis_password'] == $_POST['eleusis_password_repeat']) {
            //hier wird ueberprueft ob das indexfile fuer schreibzugriffe gerade gesperrt ist
            if(Eleusis::CheckLockfile()) {
               //liest das indexfile aus und speichert es in einem array
               $indexarray = file(ELEUSIS_BASE . '/passwordstore/indexfile');
               foreach($indexarray as $indexline_number => $indexline) {
                  //extrahiert aus dem indexfile den Nutzernamen
                  $username=substr($indexline, 0, strpos($indexline, ';'));
                  //ueberprueft ob der Nutzer schon ein passwordstore besitzt
                  if($username == Auth::getAuth()) {
                     echo "You already have a passwordstore.";
                     exit(0);
                  }
               }
               //ueberprueft ob ein passwordfile mit dem namen schon existiert           
               if(file_exists(ELEUSIS_BASE . '/passwordstore/passwords/' . $_POST['eleusis_name'])) {
                  echo "Passwordfile " . $_POST['eleusis_name'] . " already exists!<br />";
                  echo "Please try again with a new name.";
                  exit(0);
               }
               //sperrt das indexfile vor zugriffen
               fclose(fopen(ELEUSIS_BASE . '/passwordstore/indexfile.lck', 'w'));
               //oeffnet das indexfile, schreibt die neue Zuweisung hinein und schliesst die datei wieder
               $indexfile_handle=fopen(ELEUSIS_BASE . '/passwordstore/indexfile', 'a');
               fwrite($indexfile_handle, Auth::getAuth() . ';' . $_POST['eleusis_name'] . "\n");
               fclose($indexfile_handle);
               //gibt das indexfile wieder frei
               unlink(ELEUSIS_BASE . '/passwordstore/indexfile.lck');
               //erstellt eine neue Datei mit dem angegebenen Namen der passwordfile
               $passwordfile_handle=fopen(ELEUSIS_BASE . '/passwordstore/passwords/' . $_POST['eleusis_name'], 'w');
               //schreibt in die erste Zeile ein verschluesseltes "passwordfile_decrypted" damit Eleusis
               //beim entschluesseln ueberpruefen kann ob entschluesselung erfolgreich
               fwrite($passwordfile_handle, Eleusis::EncryptData($_POST['eleusis_password'], "0;eleusis_passwordfile\n"));
               //schliesst datei wieder
               fclose($passwordfile_handle);
               echo "Passwordfile \"" . $_POST['eleusis_name'] . "\" created.<br />";
            }
            //wenn das indexfile gesperrt ist, wird diese Meldung ausgegeben
            else {
               echo "Indexfile is locked. Please try again later...<br />";
               echo "<b>note:</b> If this is not the first time the file is locked, please contact the administrator!"; 
            }
         }
         //falls die Passwoerter zur Ueberpruefung der Richtigkeit unterschiedlich sind
         else {
            echo "Error: \$eleusis_password and \$eleusis_password_repeat are different!"; 
            exit(1);
         }
      }
      //falls das Passwort nicht gesetzt ist
      else {
         echo "Error: \$eleusis_password in create.php is not set or is empty!"; 
         exit(1);
      }
   }
   //falls die Variable manipuliert wurde
   else {
      echo "Error: \$eleusis_name in create.php contains illegal characters!";
      exit(1);
   }
}
//falls der Name des passwordstores nicht gesetzt ist
else {
   echo "Error: \$eleusis_name in create.php is not set or is empty!"; 
   exit(1);
}


//der footer wird includiert
require ELEUSIS_TEMPLATES . '/common-footer.inc';
?>