<?php
/**
 *
 * This product includes software developed by the Horde Project (http://www.horde.org/).
 *
 * See the enclosed file COPYING for license information (GPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 *
 * @author  Andre Pawlowski aka sqall <sqall@h4des.org>
 */

//das absolute Eleusis directory wird als Konstante definiert
//um damit config Dateien zu includieren
@define('ELEUSIS_BASE', dirname(__FILE__));

//die Basis von Eleusis wird includiert
//um die Anmeldung zu ueberpruefen
require_once(ELEUSIS_BASE . '/lib/base.php');
//die Konfigurationsdatei von Eleusis wird includiert
//um alle Eleusis Einstellungen in diesem Skript nutzen zu koennen
require(ELEUSIS_BASE . '/config/conf.php');
//das Menu von Eleusis wird includiert
//damit das Menu dem Benutzer angezeigt wird
require_once(ELEUSIS_BASE . '/list.php');

echo "<div class=\"header\">Eleusis Passwordstore</div>";
echo "<p><b>notice:</b> javascripts must be enabled!</p>";

//hier wird ueberprueft ob die zu loeschende id gesetzt ist
if(isset($_GET['id']) && $_GET['id'] != "" ) {
   //hier wird ueberprueft ob das passwordfile gesetzt ist
   if(isset($_GET['passwordfile']) && $_GET['passwordfile'] != "" ) {
      //hier wird überprüft ob jemand aus dem Ordner der passwordfiles ausbrechen will
      if(strpos($_GET['passwordfile'],'/.') === false && strpos($_GET['passwordfile'],'./') === false) {
         //hier wird ueberprueft ob das Passwort fuer das passwordfile gesetzt ist
         if(isset($_POST['passwordfile_password']) && $_POST['passwordfile_password'] != "" ) {

            //das passwordfile wird geoeffnet      
            $passwordfile_handle=fopen(ELEUSIS_BASE . '/passwordstore/passwords/' . $_GET['passwordfile'], 'r');
            //das verschluesselte passwordfile wird ausgelesen und in einer Variable gespeichert
            $encrypted_passwordfile = fread($passwordfile_handle, filesize(ELEUSIS_BASE . '/passwordstore/passwords/' . $_GET['passwordfile']));
            //das passwordfile wird wieder geschlossen
            fclose($passwordfile_handle);
            //das passwordfile wird entschluesselt
            $decrypted_passwordfile = Eleusis::DecryptData($_POST['passwordfile_password'], $encrypted_passwordfile);
            //die Variable mit dem verschluesselten Passwordfile wird geloescht
            unset($encrypted_passwordfile);
            //hier wird ueberprueft ob die entschluesselung fehlerhaft war
            if(substr($decrypted_passwordfile, 0, strpos($decrypted_passwordfile, "\n")) != "0;eleusis_passwordfile") {
               echo "Error: wrong password for decryption!";
               exit(1);
            }

            //das entschluesselte Passwordfile wird in ein array umgewandelt
            $passwordfile_as_array = explode("\n", $decrypted_passwordfile);
            unset($decrypted_passwordfile);
            //das array wird durchlaufen bis die id des zu loeschenden passworts gefunden wird
            foreach($passwordfile_as_array as $passwordfile_number => $passwordfileline) {
               //die passwort id wird extrahiert
               $id=substr($passwordfileline, 0, strpos($passwordfileline, ';'));
               //hier wird ueberprueft ob die zu loeschende id mit der des aktuellen durchlaufs uebereinstimmt
               if( $id == $_GET['id']) {
                  //wenn die id uebereinstimmt, wird das Element aus dem array entfernt (id != aktueller array key, deshalb wird $passwordfile_number verwendet)
                  unset($passwordfile_as_array[$passwordfile_number]);
                  break;
               }
            }
            //der array wird wieder in einen string umgewandelt mit "\n" als trennzeichen zwischen den elementen
            $decrypted_passwordfile = implode("\n", $passwordfile_as_array);
            unset($passwordfile_as_array);

            //das passwordfile wird geoeffnet mit dem pointer auf den anfang
            $passwordfile_handle=fopen(ELEUSIS_BASE . '/passwordstore/passwords/' . $_GET['passwordfile'], 'w');
            //das komplette passwordfile wird nun verschluesselt in die datei geschrieben
            fwrite($passwordfile_handle, Eleusis::EncryptData($_POST['passwordfile_password'], $decrypted_passwordfile));
            //schliesst datei wieder
            fclose($passwordfile_handle);

            echo "Password deleted.<br />";         
         }
         //falls das passwort fuer das passwordfile nicht gesetzt ist
         else {
            echo "Error: \$passwordfile_password in delete.php is not set or is empty!"; 
            exit(1);
         }
      }
      //falls die Variable manipuliert wurde
      else {
         echo "Error: \$passwordfile in delete.php contains illegal characters!";
         exit(1);
      }
   }
   //falls das passwordfile nicht gesetzt ist
   else {
      echo "Error: \$passwordfile in delete.php is not set or is empty!"; 
      exit(1);
   }
}
//falls die zu loeschende id nicht gesetzt ist
else {
   echo "Error: \$id in delete.php is not set or is empty!"; 
   exit(1);
}


//der footer wird includiert
require ELEUSIS_TEMPLATES . '/common-footer.inc';
?>