<?php
/**
 * Eleusis Base Class.
 *
 * $Horde: eleusis/lib/Eleusis.php,v 1.18 2008-01-02 11:14:00 jan Exp $
 *
 * Copyright 2007-2008 The Horde Project (http://www.horde.org/)
 *
 * See the enclosed file COPYING for license information (GPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 *
 * @author  Andre Pawlowski aka sqall <sqall@h4des.org>
 * @package Eleusis
 */
class Eleusis {

    /**
     * Build Eleusis's list of menu items.
     */
    function getMenu($returnType = 'object')
    {
        global $conf, $registry, $browser, $print_link;

        require_once 'Horde/Menu.php';

        $menu = new Menu(HORDE_MENU_MASK_ALL);
        $menu->add(Horde::applicationUrl('list.php'), _("List"), 'user.png', $registry->getImageDir('horde'));

        if ($returnType == 'object') {
            return $menu;
        } else {
            return $menu->render();
        }
    }
 

    //diese Funktion verschluesselt die uebergebenden Daten mit den uebergebenden key
    //und gibt die verschluesselten Daten zurueck
    function EncryptData($key, $plaintext) {
       //erstellt den initialisierungsvektor in der groesse des ausgewaehlten algorithmuses
       //aus der md5 summe des uebergebenden keys
       $iv = substr(md5($key), 0, mcrypt_get_iv_size(MCRYPT_BLOWFISH,MCRYPT_MODE_CFB));
       //verschluesselt die Daten mit dem angegebenen Modus und Algorithmuses
       return mcrypt_cfb(MCRYPT_BLOWFISH, $key, $plaintext, MCRYPT_ENCRYPT, $iv);
    }


    //diese Funktion entschluesselt die uebergebenden Daten mit den uebergebenden key
    //und gibt die entschluesselten Daten zurueck
    function DecryptData($key, $ciphertext) {
       //erstellt den initialisierungsvektor in der groesse des ausgewaehlten algorithmuses
       //aus der md5 summe des uebergebenden keys
       $iv = substr(md5($key), 0, mcrypt_get_iv_size(MCRYPT_BLOWFISH,MCRYPT_MODE_CFB));
       //entschluesselt die Daten mit dem angegebenen Modus und Algorithmuses
       return mcrypt_cfb(MCRYPT_BLOWFISH, $key, $ciphertext, MCRYPT_DECRYPT, $iv);
    }


    //diese Funktion ueberprueft ob das indexfile gesperrt ist
    function CheckLockfile() {
       //zehn mal wird maximal ueberprueft ob das indexfile gesperrt ist
       for($i=1; $i <= 10; $i++) {
          //hier wird ueberprueft ob das indexfile gesperrt ist
          if(!file_exists(ELEUSIS_BASE . '/passwordstore/indexfile.lck')) {
             return true;
          }
          else {
             sleep(1);
          }
       }
       //falls nach 10 Versuchen das indexfile noch gesperrt ist, wird false zurueck gegeben
       return false;
    }


    //diese Funktion ueberprueft ob das indexfile zu lange gesperrt ist und hebt diese sperre auf
    function CleanLockfile() {
       //ueberprueft ob das lockfile des indexfile existiert
       if(file_exists(ELEUSIS_BASE . '/passwordstore/indexfile.lck')) {
          //die creation time des lockfile wird ermittelt (Unix time)
          if($file_ctime = filectime(ELEUSIS_BASE . '/passwordstore/indexfile.lck')) {
             //die creation time des lockfile wird mit 300 sekunden (5minuten) addiert (Unix time)
             $file_ctime+=300;
             //hier wird ueberprueft ob die aktuelle Zeit (Unix time) groesser oder gleich des
             //existenzrechts fuer das lockfile ist
             if($file_ctime <= time()) {
                //das lockfile wird geloescht
                if(!unlink(ELEUSIS_BASE . '/passwordstore/indexfile.lck')) {
                   //falls ein Fehler beim loeschen auftritt, wird eine Error Nachricht ausgegeben
                   echo "Error: Unable to delete lockfile!<br />\n";
                   echo "Please contact the administrator to have the lockfile deleted.\n";
                   return false;
                }
             }
          }
          else {
             //falls die ctime der Datei nicht ermittelt werden kann, wird eine Nachricht ausgegeben
             echo "Error: Unable to get the ctime of the lockfile!<br />";
             echo "Please contact the administrator to have the lockfile deleted.\n";
             return false;
          }
       }
       return true;
    }
}
