<?php
/**
 * Eleusis base application file.
 *
 * $Horde: eleusis/lib/base.php,v 1.16 2007-02-21 10:25:28 jan Exp $
 *
 * This file brings in all of the dependencies that every Eleusis script will
 * need, and sets up objects that all scripts use.
 */

// Check for a prior definition of HORDE_BASE (perhaps by an auto_prepend_file
// definition for site customization).
if (!defined('HORDE_BASE')) {
    @define('HORDE_BASE', dirname(__FILE__) . '/../..');
}

// Load the Horde Framework core, and set up inclusion paths.
require_once HORDE_BASE . '/lib/core.php';

// Registry.
$registry = &Registry::singleton();
if (is_a(($pushed = $registry->pushApp('eleusis', !defined('AUTH_HANDLER'))), 'PEAR_Error')) {
    if ($pushed->getCode() == 'permission_denied') {
        Horde::authenticationFailureRedirect();
    }
    Horde::fatal($pushed, __FILE__, __LINE__, false);
}
$conf = &$GLOBALS['conf'];
@define('ELEUSIS_TEMPLATES', $registry->get('templates'));

// Notification system.
$notification = &Notification::singleton();
$notification->attach('status');

// Define the base file path of Eleusis.
@define('ELEUSIS_BASE', dirname(__FILE__) . '/..');

// Eleusis base library
require_once ELEUSIS_BASE . '/lib/Eleusis.php';

// Start output compression.
Horde::compressOutput();
