<?php
/**
 *
 * This product includes software developed by the Horde Project (http://www.horde.org/).
 *
 * See the enclosed file COPYING for license information (GPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 *
 * @author  Andre Pawlowski aka sqall <sqall@h4des.org>
 */

//das absolute Eleusis directory wird als Konstante definiert
//um damit config Dateien zu includieren
@define('ELEUSIS_BASE', dirname(__FILE__));

//die Basis von Eleusis wird includiert
//um die Anmeldung zu ueberpruefen
require_once(ELEUSIS_BASE . '/lib/base.php');
//die Konfigurationsdatei von Eleusis wird includiert
//um alle Eleusis Einstellungen in diesem Skript nutzen zu koennen
require(ELEUSIS_BASE . '/config/conf.php');
//das Menu von Eleusis wird includiert
//damit das Menu dem Benutzer angezeigt wird
require_once(ELEUSIS_BASE . '/list.php');

//hier wird ueberprueft ob der Name des passwordstores gesetzt ist
if(isset($_GET['passwordfile']) && $_GET['passwordfile'] != "" ) {
   //hier wird überprüft ob jemand aus dem Ordner der passwordfiles ausbrechen will
   if(strpos($_GET['passwordfile'],'/.') === false && strpos($_GET['passwordfile'],'./') === false) {
      //hier wird ueberprueft ob die zu loeschende id gesetzt ist
      if(isset($_GET['id']) && $_GET['id'] != "" ) {
         //hier wird ueberprueft ob das passwort fuer das passwordfile gesetzt ist
         if(isset($_POST['passwordfile_password']) && $_POST['passwordfile_password'] != "" ) {

            //das passwordfile wird geoeffnet      
            $passwordfile_handle=fopen(ELEUSIS_BASE . '/passwordstore/passwords/' . $_GET['passwordfile'], 'r');
            //das verschluesselte passwordfile wird ausgelesen und in einer Variable gespeichert
            $encrypted_passwordfile = fread($passwordfile_handle, filesize(ELEUSIS_BASE . '/passwordstore/passwords/' . $_GET['passwordfile']));
            //das passwordfile wird wieder geschlossen
            fclose($passwordfile_handle);
            //das passwordfile wird entschluesselt
            $decrypted_passwordfile = Eleusis::DecryptData($_POST['passwordfile_password'], $encrypted_passwordfile);
            //die Variable mit dem verschluesselten Passwordfile wird geloescht
            unset($encrypted_passwordfile);
            //hier wird ueberprueft ob die entschluesselung fehlerhaft war
            if(substr($decrypted_passwordfile, 0, strpos($decrypted_passwordfile, "\n")) != "0;eleusis_passwordfile") {
               echo "Error: wrong password for decryption!";
               exit(1);
            }

            //das entschluesselte Passwordfile wird in ein array umgewandelt
            $passwordfile_as_array = explode("\n", $decrypted_passwordfile);
            unset($decrypted_passwordfile);
            //das array wird durchlaufen bis die id des zu bearbeitenden passworts gefunden wird
            foreach($passwordfile_as_array as $passwordfile_number => $passwordfileline) {
               //die passwort id wird extrahiert
               $id=substr($passwordfileline, 0, strpos($passwordfileline, ';'));
               //hier wird ueberprueft ob die zu bearbeitende id mit der des aktuellen durchlaufs uebereinstimmt
               if( $id == $_GET['id']) {

                  //hier werden Nutzername, Passwort und Beschreibung aus jedem array Element extrahiert
                  $zwerg=substr($passwordfileline, strpos($passwordfileline, ';')+1);
                  $username=substr($zwerg, 0, strpos($zwerg, ';'));
                  $zwerg=substr($zwerg, strpos($zwerg, ';')+1);
                  $password=substr($zwerg, 0, strpos($zwerg, ';'));
                  $description=substr($zwerg, strpos($zwerg, ';')+1);

                  break;
               }
            }
         }
         //falls das passwort fuer das passwordfile nicht gesetzt ist
         else {
            echo "Error: \$passwordfile_password in modify_menu.php is not set or is empty!"; 
            exit(1);
         }
      }
      //falls die zu loeschende id nicht gesetzt ist
      else {
         echo "Error: \$id in modify_menu.php is not set or is empty!"; 
         exit(1);
      }
   }
   //falls die Variable manipuliert wurde
   else {
      echo "Error: \$passwordfile in modify_menu.php contains illegal characters!";
      exit(1);
   }
}
//falls der Name des passwordstores nicht gesetzt ist
else {
   echo "Error: \$passwordfile in modify_menu.php is not set or is empty!"; 
   exit(1);
}
?>

<script type="text/javascript" language="JavaScript">
<!--
//diese function ueberprueft die Werte des Formulars
function FormularCheck() {
   //hier wird ueberprueft ob ein Name angegeben wurde
   if(document.forms['modify_password'].elements['eleusis_name'].value != "") {
      //hier wird ueberprueft ob ein Passwort angegeben wurde
      if(document.forms['modify_password'].elements['eleusis_password'].value != "") {
         //hier wird ueberprueft ob eine Beschreibung angegeben wurde
         if(document.forms['modify_password'].elements['eleusis_description'].value != "") {
            //hier wird ueberprueft ob ein passwort fuer das passwordfile angegeben wurde
            if(document.forms['modify_password'].elements['passwordfile_password'].value != "") {
               //hier wird ueberprueft ob die beiden Passwoerter gleich sind
               if(document.forms['modify_password'].elements['eleusis_password'].value == document.forms['modify_password'].elements['eleusis_password_repeat'].value) {
                  return true;
               }
               else {
                  alert('Error: Passwords different!');
                  return false;
               }
            }
            else {
               alert('Error: No password for the passwordfile given!');
               return false;
            }
         }
         else {
            alert('Error: No description given!');
            return false;
         }
      }
      else {
         alert('Error: No password given!');
         return false;
      }
   }
   else {
      alert('Error: No name given!');
      return false;
   }
}
</script>

<div class="header">Eleusis Passwordstore</div>
<p><b>notice:</b> javascripts must be enabled!</p>

<form name="modify_password" enctype="multipart/form-data" method="post" action="modify.php<?php echo "?id=" . $_GET['id'] . "&amp;passwordfile=" . $_GET['passwordfile']?>" onsubmit="return FormularCheck()">
   <p><b>modify an username and password from the passwordstore</b></p>
   <table>
      <tr>
         <td>
            <u>description:</u>
         </td>
         <td>
            <input name="eleusis_description" type="text" value="<?php echo $description?>" />
         </td>
      </tr>
      <tr>
         <td>
            <u>username:</u>
         </td>
         <td>
            <input name="eleusis_name" type="text" value="<?php echo $username?>" />
         </td>
      </tr>
      <tr>
         <td>
            <u>password:</u>
         </td>
         <td>
            <input name="eleusis_password" type="password" value="<?php echo $password?>" />
         </td>
      </tr>
      <tr>
         <td>
            <u>repeat password:</u>
         </td>
         <td>
            <input name="eleusis_password_repeat" type="password" value="<?php echo $password?>" />
         </td>
      </tr>
   </table>
   <br /><br />
   <p><b>password for the passwordstore</b></p>
   <input name="passwordfile_password" type="password" value="<?php echo $_POST['passwordfile_password']?>" />
   <input type="submit" value="modify" />
   <input type="reset" value="reset" />
</form>

<?php
//der footer wird includiert
require ELEUSIS_TEMPLATES . '/common-footer.inc';
?>