<?php
/**
 *
 * This product includes software developed by the Horde Project (http://www.horde.org/).
 *
 * See the enclosed file COPYING for license information (GPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 *
 * @author  Andre Pawlowski aka sqall <sqall@h4des.org>
 */

//das absolute Eleusis directory wird als Konstante definiert
//um damit config Dateien zu includieren
@define('ELEUSIS_BASE', dirname(__FILE__));

//die Basis von Eleusis wird includiert
//um die Anmeldung zu ueberpruefen
require_once(ELEUSIS_BASE . '/lib/base.php');
//die Konfigurationsdatei von Eleusis wird includiert
//um alle Eleusis Einstellungen in diesem Skript nutzen zu koennen
require(ELEUSIS_BASE . '/config/conf.php');
//das Menu von Eleusis wird includiert
//damit das Menu dem Benutzer angezeigt wird
require_once(ELEUSIS_BASE . '/list.php');

?>

<script type="text/javascript" language="JavaScript">
<!--

//diese function fragt den user nochmal, ob er wirkich loeschen moechte
function DeleteForSure(id) {
   sure_delete = confirm('Are you sure you want to delete the password with the id: ' + id);
   if(sure_delete) {
      window.location="delete_menu.php?id=" + id + "&passwordfile=<?php echo $_GET['passwordfile']; ?>";
   }
}


//diese function dient zum anzeigen der passwoerter
function ShowPassword(id) {
    if (document.getElementById(id).style.display=='none') {
        document.getElementById(id).style.display='block'; 
    }
    else {
        document.getElementById(id).style.display='none';
    }
}

//-->>
</script>

<?php


echo "<div class=\"header\">Eleusis Passwordstore</div>";
echo "<p><b>notice:</b> javascripts must be enabled!</p>";

//hier wird ueberprueft ob der Name des passwordstores gesetzt ist
if(isset($_GET['passwordfile']) && $_GET['passwordfile'] != "" ) {
   //hier wird überprüft ob jemand aus dem Ordner der passwordfiles ausbrechen will
   if(strpos($_GET['passwordfile'],'/.') === false && strpos($_GET['passwordfile'],'./') === false) {
      //hier wird ueberprueft ob das Passwort des passwordstores gesetzt ist
      if(isset($_POST['passwordfile_password']) && $_POST['passwordfile_password'] != "") {
         //das passwordfile wird geoeffnet      
         $passwordfile_handle=fopen(ELEUSIS_BASE . '/passwordstore/passwords/' . $_GET['passwordfile'], 'r');
         //das verschluesselte passwordfile wird ausgelesen und in einer Variable gespeichert
         $encrypted_passwordfile = fread($passwordfile_handle, filesize(ELEUSIS_BASE . '/passwordstore/passwords/' . $_GET['passwordfile']));
         //das passwordfile wird wieder geschlossen
         fclose($passwordfile_handle);
         //das passwordfile wird entschluesselt
         $decrypted_passwordfile = Eleusis::DecryptData($_POST['passwordfile_password'], $encrypted_passwordfile);
         //die Variable mit dem verschluesselten Passwordfile wird geloescht
         unset($encrypted_passwordfile);

         //das entschluesselte Passwordfile wird von einem String in einen Array umgewandelt
         $passwordfile_as_array = explode("\n", $decrypted_passwordfile);
         //die Variable mit dem entschluesselten Passwordfile wird geloescht
         unset($decrypted_passwordfile);

         echo "<table>";
         echo "<tr>";
         echo "<td width=\"25\" bgcolor=\"#BBBBBB\">";
         echo "<b>id</b>";
         echo "</td>";
         echo "<td width=\"250\" bgcolor=\"#BBBBBB\">";
         echo "<b>description</b>";
         echo "</td>";
         echo "<td width=\"150\" bgcolor=\"#BBBBBB\">";
         echo "<b>username</b>";
         echo "</td>";
         echo "<td width=\"150\" bgcolor=\"#BBBBBB\">";
         echo "<b>password</b>";
         echo "</td>";
         echo "<td width=\"100\" bgcolor=\"#BBBBBB\">";
         echo "<b>options</b>";
         echo "</td>";
         echo "</tr>";
    
         //mit dieser variable wird der Farbwechsel der Tabellenzeilen realisiert
         $colorchange=true;
   
         //das passwordfile wird nun ausgelesen und ausgegeben
         foreach($passwordfile_as_array as $passwordfile_number => $passwordfileline) {
            //hier wird ueberprueft ob es das erste Element des Arrays ist
            if($passwordfile_number == 0) {
               //als erstes Element des Arrays muss das Schluesselwort "eleusis_passwordfile" stehen
               //ansonsten war die Entschluesselung fehlerhaft
               if($passwordfileline == "0;eleusis_passwordfile") {
                  continue;
               }
               //entschluesselung war fehlerhaft
               else {
                  echo "Error: wrong password for decryption!";
                  exit(1);
               }
            }

            //hier werden id, Nutzername, Passwort und Beschreibung aus jedem array Element extrahiert
            $id=substr($passwordfileline, 0, strpos($passwordfileline, ';'));
            $zwerg=substr($passwordfileline, strpos($passwordfileline, ';')+1);
            $username=substr($zwerg, 0, strpos($zwerg, ';'));
            $zwerg=substr($zwerg, strpos($zwerg, ';')+1);
            $password=substr($zwerg, 0, strpos($zwerg, ';'));
            $description=substr($zwerg, strpos($zwerg, ';')+1);

            //wenn die $id leer ist, wird das letzte leere element des arrays durchlaufen
            if($id == "") {
               //damit keine Ausgabe erfolgt, wird die schleife abgebrochen
               break;
            }

            //der Farbwechsel der Tabellenzeilen wird hier realisiert
            if($colorchange) {
               $colorchange=false;
               $tablecolor="#FFFFFF";
            }
            else {
               $colorchange=true;
               $tablecolor="#EEEEEE";
            }

            echo "<tr>";
            echo "<td bgcolor=\"" . $tablecolor . "\">";
            echo $id;
            echo "</td>";
            echo "<td bgcolor=\"" . $tablecolor . "\">";
            echo $description;
            echo "</td>";
            echo "<td bgcolor=\"" . $tablecolor . "\">";
            echo $username;
            echo "</td>";
            echo "<td bgcolor=\"" . $tablecolor . "\">";
            echo "<div id=\"pw_" . $id . "\" style=\"display: none;\">";
            echo $password;
            echo "</div>";
            echo "<a href=\"javascript:ShowPassword('pw_" . $id . "')\">show</a>";
            echo "</td>";
            echo "<td bgcolor=\"" . $tablecolor . "\">";
            echo "<a href=\"modify_pre_menu.php?id=" . $id . "&amp;passwordfile=" . $_GET['passwordfile'] . "\">modify</a> | <a href=\"javascript:DeleteForSure('" . $id . "')\">delete</a>";
            echo "</td>";
            echo "</tr>";

         }

         echo "</table>";
         echo "<br />";
         echo "<a href=\"add_menu.php?passwordfile=" . $_GET['passwordfile'] . "\">Add a password.</a>";

      }
      //falls das Passwort nicht gesetzt ist
      else {
         echo "Error: \$passwordfile_password in read.php is not set or is empty!"; 
         exit(1);
      }
   }
   //falls die Variable manipuliert wurde
   else {
      echo "Error: \$passwordfile in read.php contains illegal characters!";
      exit(1);
   }
}
//falls der Name des passwordstores nicht gesetzt ist
else {
   echo "Error: \$passwordfile in read.php is not set or is empty!"; 
   exit(1);
}


//der footer wird includiert
require ELEUSIS_TEMPLATES . '/common-footer.inc';
?>